<?php
 class wpsg_cache { var $_db; var $_arOrder; var $_arOrderObjects; var $_arBasket; var $_arKunden; var $_arCustomerObjects; var $_arProducts; var $_arProductObjects; var $_arMwSt; var $_BasketArray; var $_arMwStDB; public function __construct($db) { $this->_db = $db; $this->_arOrder = array(); $this->_arBasket = array(); $this->_arKunden = array(); $this->_arCustomerObjects = array(); $this->_arProducts = array(); $this->_arProductObjects = array(); $this->_arMwSt = array(); $this->_arMwStDB = false; $this->_BasketArray = false; $this->_arOrderObjects = array(); } public function loadOrder($order_id) { if (!array_key_exists($order_id, $this->_arOrder)) { $this->_arOrder[$order_id] = $this->_db->fetchRow("
					SELECT
						O.*
					FROM
						`".WPSG_TBL_ORDER."` AS O
					WHERE
						O.`id` = '".wpsg_q($order_id)."'
				"); } return $this->_arOrder[$order_id]; } public function loadOrderObject($order_id) { if (!array_key_exists($order_id, $this->_arOrderObjects)) { $this->_arOrderObjects[$order_id] = new wpsg_order($order_id); $this->_arOrderObjects[$order_id]->load($order_id); } return $this->_arOrderObjects[$order_id]; } public function clearOrderCache($order_id) { if ($order_id == false) { $this->_arOrder = array(); $this->_arOrderObjects = array(); } else { if (array_key_exists($order_id, $this->_arOrder)) unset($this->_arOrder[$order_id]); if (array_key_exists($order_id, $this->_arOrderObjects)) unset($this->_arOrderObjects[$order_id]); } } public function clearKundenCache($kunde_id = false) { if ($kunde_id == false) { $this->_arKunden = array(); $this->_arCustomerObjects = array(); } else { if (array_key_exists($kunde_id, $this->_arKunden)) unset($this->_arKunden[$kunde_id]); if (array_key_exists($kunde_id, $this->_arCustomerObjects)) unset($this->_arCustomerObjects[$kunde_id]); } } public function loadProduct($product_id) { if (!array_key_exists($product_id, $this->_arProducts)) { $this->_arProducts[$product_id] = $this->_db->fetchRow("
					SELECT
						P.*
					FROM
						`".WPSG_TBL_PRODUCTS."` AS P
					WHERE
						P.`id` = '".wpsg_q($product_id)."'
				"); } return $this->_arProducts[$product_id]; } public function loadProductObject($product_id) { if (!array_key_exists($product_id, $this->_arProductObjects)) { $this->_arOrderObjects[$product_id] = new wpsg_product(); $this->_arOrderObjects[$product_id]->load($product_id); } return $this->_arOrderObjects[$product_id]; } public function loadKunden($kunde_id) { if (!array_key_exists($kunde_id, $this->_arKunden)) { $this->_arKunden[$kunde_id] = $this->_db->fetchRow("
					SELECT
						K.*
					FROM
						`".WPSG_TBL_KU."` AS K
					WHERE
						K.`id` = '".wpsg_q($kunde_id)."'
				"); } return $this->_arKunden[$kunde_id]; } public function loadCustomerObject($customer_id) { if (!array_key_exists($customer_id, $this->_arCustomerObjects)) { $oCustomer = new wpsg_customer(); $oCustomer->load($customer_id); $this->_arCustomerObjects[$customer_id] = $oCustomer; } return $this->_arCustomerObjects[$customer_id]; } public function loadBasketArray($order_id) { if (!array_key_exists($order_id, $this->_arBasket)) { $basket = new wpsg_basket(); $basket->initFromDB($order_id); $this->_arBasket[$order_id] = $basket->toArray(); } return $this->_arBasket[$order_id]; } public function clearShopBasketArray() { $GLOBALS['wpsg_sc']->basket->initFromSession(); $this->_BasketArray = false; } public function getShopBasketArray() { if ($this->_BasketArray === false) { $this->_BasketArray = $GLOBALS['wpsg_sc']->basket->toArray(); } return $this->_BasketArray; } } ?>