<?php
 class wpsg_order extends wpsg_model { var $customer = false; var $bShippingAdress = false; var $_innerEu = null; var $_shippingZoneID = null; var $_arOrderProducts = null; public function load($order_id) { parent::load($order_id); @$this->data = &$this->shop->cache->loadOrder($order_id); @$this->customer = &$this->shop->cache->loadCustomerObject($this->data['k_id']); $this->bShippingAdress = $this->shop->callMod('wpsg_mod_shippingadress', 'check_different_shippingadress', array($this->data['k_id'], $order_id)); if ($this->data['id'] != $order_id) $this->shop->throwErrorCode('100_1'); return true; } public function log($subject, $text) { $this->db->ImportQuery(WPSG_TBL_OL, array( 'o_id' => wpsg_q($this->id), 'cdate' => 'NOW()', 'title' => wpsg_q($subject), 'mailtext' => wpsg_q($text) )); } public function getShippingTypName() { if (preg_match('/(.*)-(.*)/', $this->type_shipping)) { $arShippingKey = explode('-', $this->type_shipping); $arShippingNames = array(); foreach ($arShippingKey as $shipping_key) { $arShippingNames[] = $this->shop->getShippingName($shipping_key); } return implode(' + ', $arShippingNames); } else { return $this->shop->getShippingName($this->type_shipping); } } public function getAmount() { return wpsg_tf($this->data['price_gesamt']); } public function getCustomer() { return $this->customer; } public function getOrderProducts() { if (!is_null($this->_arOrderProducts)) return $this->_arOrderProducts; else { $arOpIds = $this->db->fetchAssocField("SELECT OP.`id` FROM `".WPSG_TBL_ORDERPRODUCT."` AS OP WHERE OP.`o_id` = '".wpsg_q($this->id)."' ORDER BY `id` ASC "); $arReturn = array(); $number = 1; foreach ($arOpIds as $order_product_id) { $oOrderProduct = new wpsg_order_product(); $oOrderProduct->load($order_product_id); $oOrderProduct->number = $number; $arReturn[] = $oOrderProduct; $number ++; } $this->_arOrderProducts = $arReturn; return $arReturn; } } public function getPaymentAmount() { return wpsg_tf($this->price_payment); } public function getPaymentID() { return $this->data['type_payment']; } public function getProductKeys() { $order_product_keys = $this->db->fetchAssocField("
				SELECT
					`productkey`
				FROM
					`".WPSG_TBL_ORDERPRODUCT."` 
				WHERE
					`o_id` = '".wpsg_q($this->id)."'	
			"); return $order_product_keys; } public function getInvoiceGender() { return $this->customer->getGender(); } public function getInvoiceFirstName() { return $this->customer->getFirstName(); } public function getInvoiceName() { return $this->customer->getName(); } public function getInvoiceStreet() { return $this->customer->getStreet(); } public function getInvoiceStreetClear() { return $this->customer->getStreetClear(); } public function getInvoiceStreetNr() { return $this->customer->getStreetNr(); } public function getInvoiceZip() { return $this->customer->getZip(); } public function getInvoiceCity() { return $this->customer->getCity(); } public function getInvoiceCountry() { return $this->customer->getCountryID(); } public function getInvoiceCountryKuerzel() { return $this->customer->getCountryKuerzel(); } public function getInvoiceCountryName() { return $this->customer->getCountryName(); } public function getShippingGender() { if ($this->bShippingAdress === true) { if (preg_match('/Frau/i', $this->shipping_title)) { return 'f'; } else { return 'm'; } } else { return $this->getInvoiceGender(); } } public function getShippingFirstName() { if ($this->bShippingAdress === true) { return $this->shipping_vname; } else { return $this->getInvoiceFirstName(); } } public function getShippingName() { if ($this->bShippingAdress === true) { return $this->shipping_name; } else { return $this->getInvoiceName(); } } public function getShippingStreetClear() { if ($this->bShippingAdress === true) { return preg_replace('/\040+\d+$/', '', $this->shipping_strasse); } else { return $this->getInvoiceStreetClear(); } } public function getShippingStreet() { if ($this->bShippingAdress === true) { return $this->shipping_strasse; } else { return $this->getInvoiceStreet(); } } public function getShippingStreetNr() { if ($this->bShippingAdress === true) { return intval(preg_replace('/(.*)\040/', '', $this->shipping_strasse)); } else { return $this->getInvoiceStreetNr(); } } public function getShippingZip() { if ($this->bShippingAdress === true) { return $this->shipping_plz; } else { return $this->getInvoiceZip(); } } public function getShippingCity() { if ($this->bShippingAdress === true) { return $this->shipping_ort; } else { return $this->getInvoiceCity(); } } public function getShippingCountryID() { if ($this->bShippingAdress) { return $this->shipping_land; } else { return $this->getInvoiceCountry(); } } public function getShippingCountryKuerzel() { if ($this->bShippingAdress === true) { return $this->db->fetchOne("SELECT `kuerzel` FROM `".WPSG_TBL_LAND."` WHERE `id` = '".wpsg_q($this->getShippingCountryID())."' "); } else { return $this->getInvoiceCountryKuerzel(); } } public function getShippingCountryName() { if ($this->bShippingAdress === true) { return $this->db->fetchOne("SELECT `name` FROM `".WPSG_TBL_LAND."` WHERE `id` = '".wpsg_q($this->getShippingCountryID())."' "); } else { return $this->getInvoiceCountryName(); } } public function getShippingZoneID() { if (is_null($this->_shippingZoneID)) { $this->_shippingZoneID = $this->db->fetchOne("
					SELECT 
						L.`vz` 
					FROM
						`".WPSG_TBL_LAND."` AS L							
					WHERE
						L.`id` = '".wpsg_q($this->getShippingCountryID())."'
				"); } return $this->_shippingZoneID; } public function isInnerEu() { if (is_null($this->_innerEu)) { $innerEu = $this->db->fetchOne("SELECT VZ.`innereu` FROM `".WPSG_TBL_VZ."` AS VZ WHERE VZ.`id` = '".wpsg_q($this->getShippingZoneID())."' "); if ($innerEu == "1") { $this->_innerEu = true; } else { $this->_innerEu = false; } } return $this->_innerEu; } public function save() { $this->db->UpdateQuery(WPSG_TBL_ORDER, $this->data, " `id` = '".wpsg_q($this->id)."' "); } public static function find($arFilter = array()) { $strQueryWHERE = ""; if (wpsg_isSizedInt($arFilter['k_id'])) { $strQueryWHERE .= " AND O.`k_id` = '".wpsg_q($arFilter['k_id'])."' "; } if (wpsg_isSizedInt($arFilter['status'])) { $strQueryWHERE .= " AND O.`status` = '".wpsg_q($arFilter['status'])."' "; } else if (wpsg_isSizedArray($arFilter['status'])) { $strQueryWHERE .= " AND O.`status` IN (".wpsg_q(implode(',', $arFilter['status'])).") "; } $strQuery = "
				SELECT
					O.`id`
				FROM
					`".WPSG_TBL_ORDER."` AS O
				WHERE
					1
					".$strQueryWHERE."	
			"; $arOrderID = $GLOBALS['wpsg_db']->fetchAssocField($strQuery); $arReturn = array(); foreach ($arOrderID as $order_id) { $oOrder = $GLOBALS['wpsg_sc']->cache->loadOrderObject($order_id); $arReturn[] = $oOrder; } return $arReturn; } } ?>