<?php
 class wpsg_mod_relatedproducts extends wpsg_mod_basic { var $lizenz = 1; var $id = 2; var $url = false; public function __construct() { parent::__construct(); $this->name = __('Zubehörprodukte', 'wpsg'); $this->group = __('Produkte', 'wpsg'); $this->desc = __('Ermöglicht es zu einem Produkt weitere Produkte als Zubehör etc. anzugeben und darzustellen.', 'wpsg'); } public function install() { require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php'); $sql = "CREATE TABLE ".WPSG_TBL_PRODUCTS_REL." (
				id mediumint(9) NOT NULL AUTO_INCREMENT,
				p_id int(11) NOT NULL,
				rel_id int(11) NOT NULL,
				template varchar(255) NOT NULL,
				PRIMARY KEY  (id),
				KEY p_id (p_id),
				KEY rel_id (rel_id)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;"; dbDelta($sql); } public function settings_edit() { $this->shop->view['wpsg_mod_relatedproducts']['arTemplates'] = $this->shop->loadProduktTemplates(true); array_unshift($this->shop->view['wpsg_mod_relatedproducts']['arTemplates'], __('Für jedes Produkt einstellbar', 'wpsg')); $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_relatedproducts/settings_edit.phtml'); } public function settings_save() { $this->shop->update_option('wpsg_mod_relatedproducts_template', $_REQUEST['wpsg_mod_relatedproducts_template']); $this->shop->update_option('wpsg_mod_relatedproducts_synchron', $_REQUEST['wpsg_mod_relatedproducts_synchron']); } public function produkt_save(&$produkt_id) { if (isset($_REQUEST['wpsg_mod_relatedproduct']) && is_array($_REQUEST['wpsg_mod_relatedproduct']) && sizeof($_REQUEST['wpsg_mod_relatedproduct']) > 0) { foreach ($_REQUEST['wpsg_mod_relatedproduct'] as $rp_id => $template) { $this->db->UpdateQuery(WPSG_TBL_PRODUCTS_REL, array( 'template' => wpsg_q($template) ), "`id` = '".wpsg_q($rp_id)."'"); } } } public function produkt_edit_sidebar(&$produkt_data) { if (isset($_REQUEST['wpsg_lang'])) return; if ($produkt_data['id'] <= 0) return; $this->shop->view['data'] = $produkt_data; $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_relatedproducts/produkt_edit_sidebar.phtml'); } public function produkt_ajax() { if (isset($_REQUEST['cmd']) && $_REQUEST['cmd'] == 'wpsg_rp_add') { if ($_REQUEST['template'] > 0 && strlen($_REQUEST['template_file']) > 0) $template = $_REQUEST['template_file']; else $template = ''; $bExists = $this->db->fetchOne("SELECT `id` FROM `".WPSG_TBL_PRODUCTS_REL."` WHERE `p_id` = '".wpsg_q($_REQUEST['edit_id'])."' AND `rel_id` = '".wpsg_q($_REQUEST['rel_id'])."'"); if ($bExists <= 0) { $this->db->ImportQuery(WPSG_TBL_PRODUCTS_REL, array( 'p_id' => wpsg_q($_REQUEST['edit_id']), 'rel_id' => wpsg_q($_REQUEST['rel_id']), 'template' => wpsg_q($template) )); } die($this->drawList($_REQUEST['edit_id'])); } else if (isset($_REQUEST['cmd']) && $_REQUEST['cmd'] == 'wpsg_rp_remove') { $this->db->Query("DELETE FROM `".WPSG_TBL_PRODUCTS_REL."` WHERE `id` = '".wpsg_q($_REQUEST['rel_id'])."'"); die($this->drawList($_REQUEST['edit_id'])); } } public function renderProdukt_afterForm(&$produkt_data, &$html) { if ($this->shop->noReleatedProducts === true) return; $arRelated = $this->getRelatedProducts($produkt_data['id']); if (is_array($arRelated) && sizeof($arRelated) > 0) { $this->shop->view['wpsg_mod_relatedproducts']['content'] = ''; foreach ($arRelated as $rp) { $this->shop->noReleatedProducts = true; if (wpsg_isSizedString($this->shop->get_option('wpsg_mod_relatedproducts_template')) && $this->shop->get_option('wpsg_mod_relatedproducts_template') != '0') { $template = $this->shop->get_option('wpsg_mod_relatedproducts_template'); } else { $template = (($rp['template'] != '' && $rp['template'] != '0')?$rp['template']:false); } $this->shop->view['wpsg_mod_relatedproducts']['content'] .= $this->shop->renderProdukt($rp['product_id'], $template); } $html .= $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_relatedproducts/relatedproducts.phtml', false); } } public function drawList($produkt_id) { $this->shop->view['wpsg_mod_relatedproducts']['arTemplates'] = $this->shop->loadProduktTemplates(true); array_unshift($this->shop->view['wpsg_mod_relatedproducts']['arTemplates'], __('Aus Produkt', 'wpsg')); $this->shop->view['wpsg_mod_relatedproducts']['data'] = $this->getRelatedProducts($produkt_id); $this->shop->view['wpsg_mod_relatedproducts']['product_id'] = $produkt_id; $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_relatedproducts/list.phtml'); } public function getRelatedProducts($produkt_id) { if ($this->shop->get_option('wpsg_mod_relatedproducts_synchron') == '1') { return $this->db->fetchAssoc("
					SELECT
						RP.`id`, RELP.`id` AS `product_id`, RELP.`name`, RP.`template`
					FROM
						`".WPSG_TBL_PRODUCTS_REL."` AS RP
							LEFT JOIN `".WPSG_TBL_PRODUCTS."` AS RELP ON (RELP.`id` = RP.`rel_id` OR RP.`p_id` = RELP.`id`)
					WHERE
						(RP.`p_id` = '".wpsg_q($produkt_id)."' OR RP.`rel_id` = '".wpsg_q($produkt_id)."') AND
						RELP.`deleted` != '1' AND RELP.`id` != '".wpsg_q($produkt_id)."'
					GROUP BY
						RELP.`id`
				"); } else { return $this->db->fetchAssoc("
					SELECT
						RP.`id`, RELP.`id` AS `product_id`, RELP.`name`, RP.`template`
					FROM
						`".WPSG_TBL_PRODUCTS_REL."` AS RP
							LEFT JOIN `".WPSG_TBL_PRODUCTS."` AS RELP ON (RELP.`id` = RP.`rel_id`)
					WHERE
						RP.`p_id` = '".wpsg_q($produkt_id)."'  AND
						RELP.`deleted` != '1' 
				"); } } } ?>